明经CAD社区

 找回密码
 注册

扫一扫,访问微社区

QQ登录

只需一步,快速开始

查看: 358|回复: 10

[源码] 文字改角度

[复制链接]
发表于 2021-4-4 10:26 | 显示全部楼层 |阅读模式
想通过线段角度刷文字角度,有个问题是目前lisp不能批量多选文字,本人不太懂lisp,请高手指点一下。另外如果可以选择多行文字,天正文字更好。

(defun c:test ( / ang obj)
(vl-load-com)
(if (and (setq obj (entsel "\n请选择直线"))
          (setq obj (vlax-ename->vla-object (car obj)))
          (= (vla-get-ObjectName obj) "AcDbLine")
          (setq ang (vla-get-Angle obj))
          (setq obj (entsel "\n请选择文字"))
          (setq obj (vlax-ename->vla-object (car obj)))
          (= (vla-get-ObjectName obj) "AcDbText")
     )
  (vla-put-Rotation obj ang)
)
(princ)
)

发表于 2021-4-4 15:26 | 显示全部楼层
换成SSGET多选啊,同时用循环批量修改就得了
发表于 2021-4-4 16:45 | 显示全部楼层
(defun c:test1 ( / ssa ssb ang i obj)
    (vl-load-com)
    (if (and
            (princ "\n请选择直线")
            (setq ssa (ssget ":S" '((0 . "line")))) ;单选一直线段
            (princ "\n请选择文字")
            (setq ssb (ssget '((0 . "text,mtext")))) ;可单选、多选、框选单行文本或多行文本
        )
        (progn
            (setq ang (vla-get-Angle (vlax-ename->vla-object (ssname ssa 0))))
            (setq i 0)
            (repeat (sslength ssb)
                 (setq obj (vlax-ename->vla-object (ssname ssb i)))
                 (vl-catch-all-apply 'vla-put-Rotation (list obj ang))
                 (setq i (1+ i))
            )
        )
     )
     (princ)
)
发表于 2021-4-4 23:10 | 显示全部楼层
能帮忙改成多义线吗, 不是直线 谢谢
发表于 2021-4-5 07:54 | 显示全部楼层
juliana207 发表于 2021-4-4 23:10
能帮忙改成多义线吗, 不是直线 谢谢

如果多段线有多段,那就比较复杂
发表于 2021-4-5 10:14 | 显示全部楼层
能帮忙改成多义线的其中一段的, 不是直线
发表于 2021-4-7 12:21 | 显示全部楼层
本帖最后由 1028695446 于 2021-4-7 12:22 编辑
bai2000 发表于 2021-4-5 10:14
能帮忙改成多义线的其中一段的, 不是直线

取2个点多好啊,还不用担心线段的方向

本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有帐号?注册

x
发表于 2021-4-8 08:18 | 显示全部楼层
1028695446 发表于 2021-4-7 12:21
取2个点多好啊,还不用担心线段的方向

要是能跟着移动到线附近就完美了
 楼主| 发表于 2021-4-8 17:57 | 显示全部楼层
yshf 发表于 2021-4-4 16:45
(defun c:test1 ( / ssa ssb ang i obj)
    (vl-load-com)
    (if (and

非常感谢老师的指点
 楼主| 发表于 2021-4-8 17:58 | 显示全部楼层
烟盒迷唇 发表于 2021-4-4 15:26
换成SSGET多选啊,同时用循环批量修改就得了

感谢提供思路
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号  
©2000-2020 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2021-4-16 19:10 , Processed in 0.469225 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.3

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表